module Ctrl
  class Board
    attr_accessor :id, :name, :labels, :closed, :url

    def initialize(opts);
      @id = opts["id"]
      @name = opts["name"]
      @url = opts["shortUrl"] || opts["url"]
      @labels = opts["labelNames"] || opts["labels"]
      @closed = opts["closed"]
      @lists = opts["lists"].map { |list| List.new(list) } if opts["lists"]
      @cards = opts["cards"].map { |card| Card.new(card) } if opts["cards"]
    end

    def save; end

    def self.create(opts); end

    def self.find_by_id(id)
      Board.new(API.get_board(id))
    end

    def self.find_by_name(name)
      fuzzy = FuzzyMatch.new(find_all, read: :name)
      fuzzy.find(name)
    end

    def self.find_all;
      API.get_boards.map { |board| Board.new(board) }
    end

    def lists
      return @lists if @lists
      API.get_lists_for_board(id).map { |list| List.new(list) }
    end

    def cards;
      return @cards if @cards
      API.get_cards_for_board(id).map { |card| Card.new(card) }
    end
  end
end
