module Ctrl
  class List
    attr_accessor :id, :name, :position, :closed

    def initialize(opts)
      @id = opts["id"]
      @name = opts["name"]
      @position = opts["pos"]
      @closed = opts["closed"]
      @cards = opts["cards"].map { |card| Card.new(card) } if opts["cards"]
      @board = Board.new(opts["board"]) if opts["board"]
      @board_id = opts["idBoard"]
    end

    def save; end

    def self.create(opts); end

    def self.find_by_id(id)
      List.new(API.get_list(id))
    end

    def self.find_by_name(name, board)
      fuzzy = FuzzyMatch.new(find_all_by_board(board.id), read: :name)
      fuzzy.find(name)
    end

    def self.find_by_position(pos, board)
      pos = 0 if pos == "first" || pos == "top"
      pos = -1 if pos == "last" || pos == "bottom"

      unless pos.is_a? Integer
        fail "Position must by integer, 'top', 'first', 'bottom', or 'last'"
      end

      find_all_by_board(board.id).sort_by(&:position)[pos]
    end

    def self.find_all_by_board(board_id)
      API.get_lists_for_board(board_id).map{ |list| List.new(list) }
    end

    def board
      @board ||= Board.find_by_id(@board_id)
    end

    def cards
      return @cards if @cards
      API.get_cards_for_list(id).map { |card| Card.new(card) }
    end

    # TODO
    #def count; end
  end
end
